/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        InternalException: an exception for error other than faults
	
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: ConnectionTimeoutException.h,v 1.1.6.1 2008/08/25 14:06:38 adorigo Exp $
*/

#ifndef _GLITE_CE_CREAM_CLIENT_API_CREAMEX_CONNTIMEX_H_
#define _GLITE_CE_CREAM_CLIENT_API_CREAMEX_CONNTIMEX_H_

#include<exception>
#include<string>

namespace glite {
  namespace ce {
    namespace cream_client_api {
      namespace cream_exceptions {

	/// An object of this class is raised as an exception when connection timeout expires
	class ConnectionTimeoutException : public std::exception {
	  
	  std::string m_error_message;
	  
	public:
	  ConnectionTimeoutException(const std::string& err_info) 
	    : m_error_message(err_info) {}
	  virtual ~ConnectionTimeoutException() throw() {}
	  virtual const char* what() const throw() { 
	    return m_error_message.c_str(); 
	  }
	};
      }
    }
  }
}

#endif
