/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        ExceptionFactory: a class that raises the proper c++ exception when a CREAM fault is received

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: ExceptionFactory.h,v 1.12.4.2 2008/08/25 14:06:38 adorigo Exp $
*/

#ifndef _GLITE_CE_CREAM_CLIENT_API_SOAPPROXY_EXFACTORY_H_
#define _GLITE_CE_CREAM_CLIENT_API_SOAPPROXY_EXFACTORY_H_

//#include "CREAM_CLIENTH.h"
//#include "CREAM_CLIENTStub.h"

#include "glite/ce/cream-client-api-c/cream_client_soapH.h"
#include "glite/ce/cream-client-api-c/cream_client_soapStub.h"

#include "glite/ce/cream-client-api-c/auth_ex.h"
#include "glite/ce/cream-client-api-c/soap_ex.h"
#include "glite/ce/cream-client-api-c/invalidTimestamp_ex.h"
#include "glite/ce/cream-client-api-c/BaseException.h"
#include "glite/ce/cream-client-api-c/JobUnknownException.h"
#include "glite/ce/cream-client-api-c/InvalidArgumentException.h"
#include "glite/ce/cream-client-api-c/OperationNotSupportedException.h"
#include "glite/ce/cream-client-api-c/NoSuitableResourceException.h"
#include "glite/ce/cream-client-api-c/GridProxyDelegationException.h"
#include "glite/ce/cream-client-api-c/JobStatusInvalidException.h"
#include "glite/ce/cream-client-api-c/GenericException.h"
//#include "glite/ce/cream-client-api-c/AuthenticationException.h"
#include "glite/ce/cream-client-api-c/AuthorizationException.h"
#include "glite/ce/cream-client-api-c/DelegationException.h"
#include "glite/ce/cream-client-api-c/InternalException.h"
#include "glite/ce/cream-client-api-c/ConnectionTimeoutException.h"
#include "glite/ce/cream-client-api-c/JobSubmissionDisabledException.h"

#include "boost/thread/recursive_mutex.hpp"

namespace cream_ex = glite::ce::cream_client_api::cream_exceptions;

namespace glite {
  namespace ce {
    namespace cream_client_api {
      namespace soap_proxy {
	namespace ExceptionFactory {

	  void raiseException(struct soap*)
	    throw(cream_ex::BaseException&,
		  cream_ex::JobUnknownException&,
		  cream_ex::InvalidArgumentException&,
		  cream_ex::OperationNotSupportedException&,
		  cream_ex::NoSuitableResourceException&,
		  cream_ex::GridProxyDelegationException&,
		  cream_ex::JobStatusInvalidException&,
		  cream_ex::GenericException&,
		  //		  cream_ex::AuthenticationException&,
		  cream_ex::AuthorizationException&,
		  cream_ex::DelegationException&,
		  cream_ex::InternalException&,
		  cream_ex::JobSubmissionDisabledException&,
		  cream_ex::ConnectionTimeoutException&);
	  
	  std::string makeStringFromFault( CREAMTYPES__BaseFaultType* ) throw();
	  
	};
      }
      }
      }
      }
#endif

