/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        GridProxyDelegationException: an exception a grid proxy Cream's fault
	
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: GridProxyDelegationException.h,v 1.4.4.1 2008/08/25 14:06:38 adorigo Exp $
*/

#ifndef _GLITE_CE_CREAM_CLIENT_API_CREAMEX_GPDEX_H_
#define _GLITE_CE_CREAM_CLIENT_API_CREAMEX_GPDEX_H_

#include "glite/ce/cream-client-api-c/BaseException.h"

namespace glite {
  namespace ce {
    namespace cream_client_api {
      namespace cream_exceptions {
	
	/// An object of this class is raised as an exception when the remote CREAM web service sends back a DelegationIdMismatchFault fault to the client as result of an operation using a delegation identifier that the service doesn't recognize
	class GridProxyDelegationException : public BaseException {
	  
	public:
	  GridProxyDelegationException(const std::string& mn,
				       const std::string& ec,
				       const std::string& des,
				       const std::string& fc,
				       const time_t& t) : BaseException(mn, ec, des, fc, t) {}
	  virtual ~GridProxyDelegationException() throw() {}
	};
      }
    }
  }
}

#endif
