/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        classad_syntax_ex: an exception for wrong classads

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: classad_syntax_ex.h,v 1.3 2006/04/26 09:46:34 adorigo Exp $
*/

#ifndef _GLITE_CE_CREAM_CLIENT_API_UTIL_CLASSADSYNTAXEX_H_
#define _GLITE_CE_CREAM_CLIENT_API_UTIL_CLASSADSYNTAXEX_H_

#include<exception>
#include<string>

namespace glite {
  namespace ce {
    namespace cream_client_api {
      namespace util {		
	class classad_syntax_ex : public std::exception {
	  
	  std::string m_error_message;
	  
	public:
	  classad_syntax_ex(const std::string& err_info) : m_error_message(err_info) {}
	  virtual ~classad_syntax_ex() throw() {}
	  virtual const char* what() const throw() { return m_error_message.c_str(); }
	  
	};
      }
    }
  }
}

#endif
